qemu-devel
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Re: [Qemu-devel] [PATCH 1/3] scripts: Add new clean-includes script to f


From: Daniel P. Berrange
Subject: Re: [Qemu-devel] [PATCH 1/3] scripts: Add new clean-includes script to fix C include directives
Date: Mon, 11 Jan 2016 15:23:57 +0000
User-agent: Mutt/1.5.24 (2015-08-30)

On Mon, Dec 07, 2015 at 04:23:43PM +0000, Peter Maydell wrote:
> Add a new scripts/clean-includes, which can be used to automatically
> ensure that a C source file includes qemu/osdep.h first and doesn't
> then include any headers which osdep.h provides already.
> 
> Signed-off-by: Peter Maydell <address@hidden>
> ---
>  scripts/clean-includes | 109 
> +++++++++++++++++++++++++++++++++++++++++++++++++
>  1 file changed, 109 insertions(+)
>  create mode 100755 scripts/clean-includes
> 
> diff --git a/scripts/clean-includes b/scripts/clean-includes
> new file mode 100755
> index 0000000..1af1f82
> --- /dev/null
> +++ b/scripts/clean-includes
> @@ -0,0 +1,109 @@
> +#!/bin/sh -e
> +#
> +# Clean up QEMU #include lines by ensuring that qemu/osdep.h
> +# is the first include listed.
> +#
> +# Copyright (c) 2015 Linaro Limited
> +#
> +# Authors:
> +#  Peter Maydell <address@hidden>
> +#
> +# This work is licensed under the terms of the GNU GPL, version 2
> +# or (at your option) any later version. See the COPYING file in
> +# the top-level directory.
> +
> +# Usage:
> +#   clean-includes [--git subjectprefix] file ...
> +#
> +# If the --git subjectprefix option is given, then after making
> +# the changes to the files this script will create a git commit
> +# with the subject line "subjectprefix: Clean up includes"
> +# and a boilerplate commit message.
> +
> +# This script requires Coccinelle to be installed.
> +
> +
> +# The following one-liner may be handy for finding files to run this on.
> +# However some caution is required regarding files that might be part
> +# of the guest agent or standalone tests.
> +
> +# for i in `git ls-tree --name-only HEAD`  ; do test -f $i && \
> +#   grep -E '^# *include' $i | head -1 | grep 'osdep.h' ; test $? != 0 && \
> +#   echo $i ; done
> +
> +
> +GIT=no
> +
> +if [ $# -ne 0 ] && [ "$1" = "--git" ]; then
> +    if [ $# -eq 1 ]; then
> +        echo "--git option requires an argument"
> +        exit 1
> +    fi
> +    GITSUBJ="$2"
> +    GIT=yes
> +    shift
> +    shift
> +fi
> +
> +if [ $# -eq 0 ]; then
> +    echo "Usage: clean-includes [--git subjectprefix] foo.c ..."
> +    echo "(modifies the files in place)"
> +    exit 1
> +fi
> +
> +# Annoyingly coccinelle won't read a scriptfile unless its
> +# name ends '.cocci', so write it out to a tempfile with the
> +# right kind of name.
> +COCCIFILE="$(mktemp --suffix=.cocci)"
> +
> +trap 'rm -f -- "$COCCIFILE"' INT TERM HUP EXIT
> +
> +cat >"$COCCIFILE" <<EOT
> +@@
> +@@
> +
> +(
> ++ #include "qemu/osdep.h"
> + #include "..."
> +|
> ++ #include "qemu/osdep.h"
> + #include <...>
> +)
> +EOT
> +
> +
> +for f in "$@"; do
> +  # First, use coccinelle to add qemu/osdep.h before the first existing 
> include
> +  # (this will add two lines if the file uses both "..." and <...> #includes,
> +  # but we will remove the extras in the next step)
> +  spatch  --in-place --no-show-diff --cocci-file "$COCCIFILE" "$f"
> +
> +  # Now remove any duplicate osdep.h includes
> +  perl -n -i  -e 'print if !/#include "qemu\/osdep.h"/ || !$n++;' "$f"
> +
> +  # Remove includes that osdep.h already provides
> +  perl -n -i -e 'print if !/\s*#\s*include\s*(["<][^>"]*[">])/ ||
> +                          ! (grep { $_ eq $1 } qw (
> +           "config-host.h" "qemu/compiler.h" "config.h"
> +           <stdarg.h> <stddef.h> <stdbool.h> <stdint.h> <sys/types.h>
> +           <stdlib.h> <stdio.h> <string.h> <strings.h> <inttypes.h>
> +           <limits.h> <unistd.h> <time.h> <ctype.h> <errno.h> <fcntl.h>
> +           <sys/stat.h> <sys/time.h> <assert.h> <signal.h>
> +           "glib-compat.h" "qapi/error.h"
> +            ))' "$f"
> +
> +done
> +
> +if [ "$GIT" = "yes" ]; then
> +    git add -- "$@"
> +    git commit --signoff -F - <<EOF
> +$GITSUBJ: Clean up includes
> +
> +Clean up includes so that osdep.h is included first and headers
> +which it implies are not included manually.
> +
> +This commit was created with scripts/clean-includes.
> +
> +EOF
> +
> +fi
> -- 

Reviewed-by: Daniel P. Berrange <address@hidden>


Regards,
Daniel
-- 
|: http://berrange.com      -o-    http://www.flickr.com/photos/dberrange/ :|
|: http://libvirt.org              -o-             http://virt-manager.org :|
|: http://autobuild.org       -o-         http://search.cpan.org/~danberr/ :|
|: http://entangle-photo.org       -o-       http://live.gnome.org/gtk-vnc :|



reply via email to

[Prev in Thread] Current Thread [Next in Thread]